/**
 * Public API for plugin implementors
 *
 * @packageDocumentation
 */
import type z from 'zod';
import type { PluginMetadata } from './plugin-metadata';
import type { PluginDefinition } from './plugin-registry';
import type { Rule, RuleDef, RuleOptionSchema } from './rules';
import type * as schemaUtils from './schema-util';
export type * as Result from './rules/result';
export { z, z as zod, type PluginDefinition, type PluginMetadata, type Rule, type RuleDef, type RuleOptionSchema, };
export interface PluginAPI {
    metadata: PluginMetadata;
    defineRule: typeof defineRule;
    z: typeof z;
    zod: typeof z;
    activePlugins: PluginMetadata[];
    schemaUtils: typeof schemaUtils;
}
export declare function defineRule<const Name extends string, Schema extends RuleOptionSchema | void = void>(ruleDef: RuleDef<Name, Schema>): RuleDef<Name, Schema>;
//# sourceMappingURL=plugin-api.d.ts.map