"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.PluginMetadata = void 0;
const node_path_1 = __importDefault(require("node:path"));
class PluginMetadata {
    constructor(optsOrEntryPoint, name) {
        if (typeof optsOrEntryPoint === 'string') {
            optsOrEntryPoint = {
                entryPoint: optsOrEntryPoint,
                requestedAs: optsOrEntryPoint,
                name: name ?? node_path_1.default.relative(process.cwd(), optsOrEntryPoint),
            };
        }
        this.name = optsOrEntryPoint.name;
        this.version = optsOrEntryPoint.version;
        this.requestedAs =
            optsOrEntryPoint.requestedAs ?? optsOrEntryPoint.entryPoint;
        this.entryPoint = optsOrEntryPoint.entryPoint;
        this.ruleConts = new Map();
    }
    toString() {
        return `${this.name}${this.version ? `@${this.version}` : ''} (${this.entryPoint})`;
    }
}
exports.PluginMetadata = PluginMetadata;
//# sourceMappingURL=plugin-metadata.js.map