export interface SmokerPlugin<Instance = unknown, Deps = unknown[]> {
    plugin(): Instance;
    needs?: Deps;
}
export type DependenciesOf<Plugin extends SmokerPlugin> = Plugin extends SmokerPlugin<any, infer Deps extends SmokerPlugin[]> ? Deps : never;
type PluginDependencyError = `Plugin is missing one or more dependencies.`;
type UnionToIntersection<U> = (U extends unknown ? (k: U) => void : never) extends (k: infer I) => void ? I : never;
declare class SmokerPluginRegistry<Plugins extends SmokerPlugin[] = []> {
    register<Plugin extends SmokerPlugin>(plugin: Plugin): SmokerPluginRegistry<[...Plugins, Plugin]>;
    plugin(): MergeInterfaces<this, 'plugin'>;
}
type Defined<T> = T extends undefined ? never : T;
export type PluginsOf<T> = T extends SmokerPluginRegistry<infer V> ? V : never;
type MergeInterfaces<E extends SmokerPluginRegistry, K extends keyof SmokerPlugin> = UnionToIntersection<ReturnType<Defined<PluginsOf<E>[number][K]>>>;
export type CheckDependencies<Registry extends SmokerPluginRegistry, Plugin extends SmokerPlugin> = DependenciesOf<Plugin>[number] extends PluginsOf<Registry>[number] ? Plugin : PluginDependencyError;
export {};
//# sourceMappingURL=plugin.d.ts.map