import z from 'zod';
import { PackedPackage, RuleDef, RuleOptionSchema } from '.';
import { type PluginAPI } from './plugin-api';
import { PluginRegistry } from './plugin-registry';
import { RawCheckOptions, Rule } from './rules';
export { PluginRegistry };
export declare function setupRuleTest(baseDir: string, fixtureName: string, config?: RawCheckOptions): {
    ruleConfig: Record<string, "error" | "warn" | "off" | {
        [x: string]: any;
        [x: number]: any;
    } | z.objectInputType<Omit<{
        [x: string]: z.ZodOptional<any> | z.ZodDefault<any>;
    }, "opts">, z.ZodTypeAny, "passthrough"> | ["error" | "warn" | "off" | undefined, {
        [x: string]: any;
        [x: number]: any;
    } | z.objectInputType<Omit<{
        [x: string]: z.ZodOptional<any> | z.ZodDefault<any>;
    }, "opts">, z.ZodTypeAny, "passthrough"> | undefined] | {
        severity?: "error" | "warn" | "off" | undefined;
        opts?: {
            [x: string]: any;
            [x: number]: any;
        } | z.objectInputType<Omit<{
            [x: string]: z.ZodOptional<any> | z.ZodDefault<any>;
        }, "opts">, z.ZodTypeAny, "passthrough"> | undefined;
    } | undefined>;
    pkg: PackedPackage;
};
export declare function applyRule(rule: Rule<any, any>, config: RawCheckOptions, { installPath: pkgPath }: PackedPackage): Promise<import(".").CheckResults>;
export declare function fromRuleFactory<const Name extends string, Schema extends RuleOptionSchema | void = void>(factory: (api: PluginAPI) => RuleDef<Name, Schema>): Rule<Name, Schema>;
//# sourceMappingURL=test-api.d.ts.map