"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.fromRuleFactory = exports.applyRule = exports.setupRuleTest = exports.PluginRegistry = void 0;
const node_events_1 = require("node:events");
const node_fs_1 = __importDefault(require("node:fs"));
const node_path_1 = __importDefault(require("node:path"));
const zod_1 = __importDefault(require("zod"));
const _1 = require(".");
const plugin_api_1 = require("./plugin-api");
const plugin_metadata_1 = require("./plugin-metadata");
const plugin_registry_1 = require("./plugin-registry");
Object.defineProperty(exports, "PluginRegistry", { enumerable: true, get: function () { return plugin_registry_1.PluginRegistry; } });
const rules_1 = require("./rules");
const schemaUtils = __importStar(require("./schema-util"));
function setupRuleTest(baseDir, fixtureName, config = {}) {
    const installPath = node_path_1.default.join(baseDir, 'fixture', fixtureName);
    try {
        node_fs_1.default.statSync(installPath);
    }
    catch {
        throw new Error(`Fixture "${fixtureName}" not found`);
    }
    const pkg = {
        pkgName: '',
        installPath,
        tarballFilepath: '',
    };
    return { ruleConfig: config, pkg };
}
exports.setupRuleTest = setupRuleTest;
async function applyRule(rule, config, { installPath: pkgPath }) {
    return _1.Smoker.prototype.runCheck.call(new node_events_1.EventEmitter(), rule.toRuleCont(), pkgPath, { [rule.name]: rule.zRuleSchema.parse(config?.[rule.name]) });
}
exports.applyRule = applyRule;
function fromRuleFactory(factory) {
    const api = {
        metadata: new plugin_metadata_1.PluginMetadata('/some/path.js', 'some-name'),
        z: zod_1.default,
        zod: zod_1.default,
        defineRule: plugin_api_1.defineRule,
        schemaUtils,
        activePlugins: [],
    };
    return new rules_1.Rule(factory(api));
}
exports.fromRuleFactory = fromRuleFactory;
//# sourceMappingURL=test-api.js.map